#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include   <stdint.h>
#include  <math.h>

#include  "../tthimage.h"

/*		==============================				*/
int essai_show_t16x24( char *text)
{
if (NULL != text)
	Image_t16x24_essai("16x24thin", text, "16x24.tga");
else
	Image_t16x24_essai("16x24gruik", "0123456789abcdef", "16x24.tga");
return 0;
}

/*		==============================				*/

void essai_gradients(void)
{
int		foo;

foo = Image_plot_H_gradient("foo.tga", 640, 200);
fprintf(stderr, "plot h gradient -> %d\n", foo);
foo = Image_plot_V_gradient("foo.tga", 900, 200);
fprintf(stderr, "plot v gradient -> %d\n", foo);
}
/*		==============================				*/
int essai_draw_paint_rect(char *outga)
{
Image_Desc		*img;
Image_Rect		rect;
int			foo, x, y;

fprintf(stderr, ">>> %s ( '%s' )\n", __func__, outga);

rect.x = 8;		rect.y = 8;
rect.w = 6;		rect.h = 6;

if (NULL==(img=Image_alloc(64, 32, 3))) {
	abort();
	}

for (x=0; x<img->width; x+=2) {
	for (y=0; y<img->height; y+=2) {
		Image_plotRGB(img, x, y, 200, 200, 200);
		}
	}

foo = Image_draw_rect(img, &rect, 192, 128, 64);
if (foo) {
	fprintf(stderr, "%s: err %d draw rect\n", __func__, foo);
	return foo;
	}

rect.x = 24;
foo = Image_paint_rect(img, &rect, 64, 128, 192);
if (foo) {
	fprintf(stderr, "%s: err %d paint rect\n", __func__, foo);
	return foo;
	}

foo = Image_TGA_save(outga, img, 0);
if (foo) {
	fprintf(stderr, "%s: err %d save '%s'\n", __func__, foo, outga);
	return foo;
	}

return OLL_KORRECT;
}
/*		==============================				*/

int main(int argc, char *argv[])
{
int		foo;

essai_gradients();

#if 0
Image_print_version(2);
Image_print_sizeof_structs("foo");

foo = essai_show_t16x24(NULL);
fprintf(stderr, "essai show t16x24 --> %d\n", foo);

foo = essai_draw_paint_rect("foo.tga");
fprintf(stderr, "essai draw rect --> %d\n", foo);

Image_egalise_cos01(NULL, NULL, 0);
#endif

return 0;
}
